-- name: [CS] DK Arcade Pack
-- description: [CS] DK Arcade Pack\n\nThis mod adds Jumpman and Stanley from the Donkey Kong, Donkey Kong Jr. and Donkey Kong 3 arcade videogames\ninto sm64coopdx!\n\n\\#f54e59\\Credits: \nAlexXRGames, ThaGurlTilly, \n\\#008800\\Squishy6094,\n\\#5ff54e\\BlueKazoo & Brobgonal Second\n\n\\#ffffff\\Requires \\#00ff00\\Character Select \\#ff6868\\enabled!

local TEXT_PACK_NAME = "DK Arcade Pack"
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_PACK_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod and Restart the Room!", 6)
    return
end

local E_MODEL_JUMPMAN = smlua_model_util_get_id("jumpman_geo")
local E_MODEL_STANLEY = smlua_model_util_get_id("stanley_geo")
local E_MODEL_JUMPMAN_ALT_1 = smlua_model_util_get_id("jumpman_alt_geo")
local E_MODEL_STANLEY_ALT_1 = smlua_model_util_get_id("stanley_alt_geo")
local E_MODEL_JUMPMAN_ALT_2 = smlua_model_util_get_id("jumpman_alt2_geo")
local E_MODEL_STANLEY_ALT_2 = smlua_model_util_get_id("stanley_alt2_geo")

local TEX_JUMPMAN = get_texture_info("jumpman-icon")
local TEX_STANLEY = get_texture_info("stanley-icon")

local VOICETABLE_JUMPMAN = {
    [CHAR_SOUND_ATTACKED] = "jumpman_thwomp.ogg",
    [CHAR_SOUND_DOH] = "jumpman_thwomp.ogg",
    [CHAR_SOUND_DROWNING] = "jumpman_miss.ogg",
    [CHAR_SOUND_DYING] = "jumpman_miss.ogg",
    [CHAR_SOUND_GROUND_POUND_WAH] = "jumpman_kick.ogg",
    [CHAR_SOUND_HAHA] = "jumpman_kick.ogg",
    [CHAR_SOUND_HAHA_2] = "jumpman_kick.ogg",
    [CHAR_SOUND_HERE_WE_GO] = "jumpman_herewego.ogg",
    [CHAR_SOUND_HOOHOO] = "jumpman_thwomp.ogg",
    [CHAR_SOUND_MAMA_MIA] = "jumpman_kick.ogg",
    [CHAR_SOUND_OKEY_DOKEY] = "jumpman_kick.ogg",
    [CHAR_SOUND_ON_FIRE] = "jumpman_pause.ogg",
    [CHAR_SOUND_OOOF] = "jumpman_thwomp.ogg",
    [CHAR_SOUND_OOOF2] = "jumpman_thwomp.ogg",
    [CHAR_SOUND_PUNCH_HOO] = "jumpman_kick.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "jumpman_thwomp.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "jumpman_thwomp.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = "jumpman_fall.ogg",
    [CHAR_SOUND_TWIRL_BOUNCE] = "jumpman_pause.ogg",
    [CHAR_SOUND_WAAAOOOW] = "jumpman_fall.ogg",
    [CHAR_SOUND_WAH2] = "jumpman_kick.ogg",
    [CHAR_SOUND_WHOA] = "jumpman_thwomp.ogg",
    [CHAR_SOUND_YAHOO] = "jumpman_kick.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = "jumpman_herewego.ogg",
    [CHAR_SOUND_YAH_WAH_HOO] = "jumpman_jump.ogg",
    [CHAR_SOUND_YAWNING] = "jumpman_pause.ogg",
}
local VOICETABLE_STANLEY = {
    [CHAR_SOUND_ATTACKED] = "stanley_attacked.ogg",
    [CHAR_SOUND_DOH] = "stanley_yah.ogg",
    [CHAR_SOUND_DROWNING] = "stanley_miss.ogg",
    [CHAR_SOUND_DYING] = "stanley_miss.ogg",
    [CHAR_SOUND_GROUND_POUND_WAH] = "stanley_haha.ogg",
    [CHAR_SOUND_HAHA] = "stanley_haha.ogg",
    [CHAR_SOUND_HAHA_2] = "stanley_haha.ogg",
    [CHAR_SOUND_HERE_WE_GO] = "stanley_yahoo.ogg",
    [CHAR_SOUND_HOOHOO] = "stanley_hoohoo.ogg",
    [CHAR_SOUND_MAMA_MIA] = "stanley_mamamia.ogg",
    [CHAR_SOUND_OKEY_DOKEY] = "stanley_yahoo.ogg",
    [CHAR_SOUND_ON_FIRE] = "jumpman_pause.ogg",
    [CHAR_SOUND_OOOF] = "stanley_oof.ogg",
    [CHAR_SOUND_OOOF2] = "stanley_oof.ogg",
    [CHAR_SOUND_PUNCH_HOO] = "stanley_hoo.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "stanley_yah_wah.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "stanley_yah_wah.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = "stanley_fall.ogg",
    [CHAR_SOUND_TWIRL_BOUNCE] = "jumpman_pause.ogg",
    [CHAR_SOUND_WAAAOOOW] = "stanley_fall.ogg",
    [CHAR_SOUND_WAH2] = "jumpman_kick.ogg",
    [CHAR_SOUND_WHOA] = "stanley_haha.ogg",
    [CHAR_SOUND_YAHOO] = "stanley_yah.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = "stanley_yahoo.ogg",
    [CHAR_SOUND_YAH_WAH_HOO] = "stanley_yah.ogg",
    [CHAR_SOUND_YAWNING] = "jumpman_pause.ogg",
}

local PALETTE_JUMPMAN = {
    [PANTS]  = { r = 0xFF, g = 0x00, b = 0x00 },
    [SHIRT]  = { r = 0x4F, g = 0x5A, b = 0xFF },
    [GLOVES] = { r = 0xFF, g = 0xFF, b = 0xFF },
    [SHOES]  = { r = 0x00, g = 0x00, b = 0x00 },
    [HAIR]   = { r = 0x00, g = 0x00, b = 0x00 },
    [SKIN]   = { r = 0xFE, g = 0xC1, b = 0x79 },
    [CAP]    = { r = 0xFF, g = 0x00, b = 0x00 },
    [EMBLEM] = { r = 0xDC, g = 0x9F, b = 0xFF }
}

local PALETTE_JUMPMAN_ALT = {
    [PANTS]  = { r = 0xC0, g = 0x24, b = 0x08 },
    [SHIRT]  = { r = 0x37, g = 0x3D, b = 0xE3 },
    [GLOVES] = { r = 0xEB, g = 0xEB, b = 0xFF },
    [SHOES]  = { r = 0x4F, g = 0x29, b = 0x15 },
    [HAIR]   = { r = 0x0E, g = 0x0A, b = 0x0A },
    [SKIN]   = { r = 0xE9, g = 0x97, b = 0x68 },
    [CAP]    = { r = 0xC0, g = 0x24, b = 0x08 },
    [EMBLEM] = { r = 0xFF, g = 0xFF, b = 0xFF }
}

local PALETTE_STANLEY = {
    [PANTS]  = { r = 0xFF, g = 0xFF, b = 0xFF },
    [SHIRT]  = { r = 0x00, g = 0x00, b = 0xFF },
    [GLOVES] = { r = 0xFF, g = 0xFF, b = 0xFF },
    [SHOES]  = { r = 0x72, g = 0x1C, b = 0x0E },
    [HAIR]   = { r = 0x73, g = 0x06, b = 0x00 },
    [SKIN]   = { r = 0xFE, g = 0xC1, b = 0x79 },
    [CAP]    = { r = 0x00, g = 0x00, b = 0xFF },
    [EMBLEM] = { r = 0xFF, g = 0x00, b = 0x00 }
}

local CT_JUMPMAN = _G.charSelect.character_add("Jumpman", {"Jumpman is a plumber from New York,", "which first appeared in the videogame 'Donkey Kong'.", "", "One day, a lady called 'Pauline' got kidnapped", "by a monkey called 'Donkey Kong', and he has taken", "her to a dangerous construction site, and now,", "Jumpman has to climb up the dangerous construction", "site to defeat Donkey Kong and rescue her!" }, "AlexXRGames, ThaGurlTilly & Brob2nd", { r = 255, g = 0, b = 80 }, E_MODEL_JUMPMAN, CT_MARIO, TEX_JUMPMAN)
local CT_STANLEY = _G.charSelect.character_add("Stanley", {"Stanley, also known as Stanley the Bugman,", "is a bug exterminator who first appeared in the", "Game & Watch game Green House.", "In that game, Stanley uses his", "spray gun to defeat hungry pests.", "He later appeared in the Donkey Kong Arcade franchise", "as the protagonist of the game Donkey Kong 3,", "in which he battles with Donkey Kong and", "several insects in a greenhouse with his spray."}, "BlueKazoo & Brobgonal Second", { r = 0, g = 111, b = 222 }, E_MODEL_STANLEY, CT_MARIO, TEX_STANLEY)
_G.charSelect.character_add_voice(E_MODEL_JUMPMAN, VOICETABLE_JUMPMAN)
_G.charSelect.character_add_voice(E_MODEL_STANLEY, VOICETABLE_STANLEY)
_G.charSelect.character_add_voice(E_MODEL_JUMPMAN_ALT_1, VOICETABLE_JUMPMAN)
_G.charSelect.character_add_voice(E_MODEL_STANLEY_ALT_1, VOICETABLE_STANLEY)
_G.charSelect.character_add_voice(E_MODEL_JUMPMAN_ALT_2, VOICETABLE_JUMPMAN)
_G.charSelect.character_add_voice(E_MODEL_STANLEY_ALT_2, VOICETABLE_STANLEY)
_G.charSelect.character_add_palette_preset(E_MODEL_JUMPMAN, PALETTE_JUMPMAN)
_G.charSelect.character_add_palette_preset(E_MODEL_STANLEY, PALETTE_STANLEY)
_G.charSelect.character_add_palette_preset(E_MODEL_JUMPMAN_ALT_1, PALETTE_JUMPMAN_ALT)
_G.charSelect.character_add_palette_preset(E_MODEL_STANLEY_ALT_1, PALETTE_STANLEY)
_G.charSelect.character_add_palette_preset(E_MODEL_JUMPMAN_ALT_2, PALETTE_JUMPMAN_ALT)
_G.charSelect.character_add_palette_preset(E_MODEL_STANLEY_ALT_2, PALETTE_STANLEY)


local voiceTables = {
    [VOICETABLE_JUMPMAN] = true,
    [VOICETABLE_STANLEY] = true
}

--- @param m MarioState
local function mario_update(m)
    if is_player_active(m) == 0 then return end
    local voiceTable = charSelect.character_get_voice(m)
    if voiceTables[voiceTable] then
        return charSelect.voice.snore(m)
    end
end

--- @param m MarioState
--- @param sound CharacterSound
local function character_sound(m, sound)
    local voiceTable = charSelect.character_get_voice(m)
    if voiceTables[voiceTable] then
        return charSelect.voice.sound(m, sound)
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_CHARACTER_SOUND, character_sound)


-----------------------------------
--- Alt Costume code by Squishy ---
-----------------------------------

local character_edit = _G.charSelect.character_edit
local character_get_current_number = _G.charSelect.character_get_current_number
local character_get_current_table = _G.charSelect.character_get_current_table
local get_options_status = _G.charSelect.get_options_status
local get_menu_color = _G.charSelect.get_menu_color
local hook_render_in_menu = _G.charSelect.hook_render_in_menu

local table_insert = table.insert
local play_sound = play_sound
local djui_hud_get_screen_width = djui_hud_get_screen_width
local djui_hud_measure_text = djui_hud_measure_text
local djui_hud_set_color = djui_hud_set_color
local djui_hud_set_resolution = djui_hud_set_resolution
local djui_hud_set_rotation = djui_hud_set_rotation
local djui_hud_set_font = djui_hud_set_font
local djui_hud_print_text = djui_hud_print_text
local djui_hud_render_rect = djui_hud_render_rect
local maxf = maxf
local math_min = math.min
local math_max = math.max
local math_sin = math.sin

local altCostumes = {
    [CT_JUMPMAN] = {
        currSkin = 1,
        {name = "",      model = E_MODEL_JUMPMAN, --[[tex = TEX_JUMPMAN, desc = {""}]]},
        {name = "Alt", model = E_MODEL_JUMPMAN_ALT_1, --[[tex = TEX_JUMPMAN, desc = {""}]]},
        {name = "Render96", model = E_MODEL_JUMPMAN_ALT_2, --[[tex = TEX_JUMPMAN, desc = {""}]]},
    },
    [CT_STANLEY] = {
        currSkin = 1,
        {name = "",      model = E_MODEL_STANLEY, --[[tex = TEX_JUMPMAN, desc = {""}]]},
        {name = "Alt 1", model = E_MODEL_STANLEY_ALT_1, --[[tex = TEX_JUMPMAN, desc = {""}]]},
        {name = "Alt 2", model = E_MODEL_STANLEY_ALT_2, --[[tex = TEX_JUMPMAN, desc = {""}]]},
    },
}

local function update_character_skin(currChar, currAlt)
    local currSkin = altCostumes[currChar][currAlt]
    if altCostumes[currChar].desc == nil then
        altCostumes[currChar].desc = character_get_current_table().description
    end
    if currSkin.desc == nil then
        currSkin.desc = altCostumes[currChar].desc
    end
    local description = {}
    for i = 1, #currSkin.desc do
        table_insert(description, currSkin.desc[i])
    end
    if currSkin.name ~= "" then
        table_insert(description, "")
        table_insert(description, "Current Outfit: "..currSkin.name)
    end
    character_edit(currChar, nil, description, nil, nil, currSkin.model, nil--[[, currSkin.tex]])
    local cameraToObject = gMarioStates[0].marioObj.header.gfx.cameraToObject
    play_sound(SOUND_MENU_MESSAGE_NEXT_PAGE, cameraToObject)
end

local inputLockTimer = 0
local buttonAnimTimer = 0

local MATH_DIVIDE_320 = 1/320

local latencyValueTable = {12, 6, 3}

local function hud_render()
    local width = djui_hud_get_screen_width() + 1.4
    local widthScale = maxf(width, 321.4) * MATH_DIVIDE_320
    local currChar = character_get_current_number()
    local charColors = character_get_current_table().color
    
    -- Mimick button swaying, which is missing from the paper code
    local buttonAnim = 0
    local charSelectAnim = get_options_status(_G.charSelect.optionTableRef.anims)
    if charSelectAnim > 0 then
        buttonAnimTimer = buttonAnimTimer + 1
        buttonAnim = math_sin(buttonAnimTimer * 0.05) * 2.5 + 5
    else
        buttonAnim = 10
    end

    local inputLockTimerTo = latencyValueTable[get_options_status(_G.charSelect.optionTableRef.inputLatency) + 1]

    if altCostumes[currChar] ~= nil then
        ---@type Controller
        local c = _G.charSelect.controller
        local currAlts = altCostumes[currChar]

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local inputLockTimerAnim = 0

        local buttonX = 20 * widthScale + buttonAnim
        local x1 = buttonX - 4
        local x2 = x1 + 73
        local y = 97

        if charSelectAnim > 0 then
            inputLockTimerAnim = inputLockTimer/inputLockTimerTo * 3
            x1 = x1 + math_min(inputLockTimerAnim, 0)
            x2 = x2 + math_max(inputLockTimerAnim, 0)
        end
        -- Left Arrow
        if currAlts.currSkin > 1 then
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_set_rotation(0x2000, 0.5, 0.5)
            djui_hud_render_rect(x1, y, 5, 5)
            djui_hud_set_color(0, 0, 0, 255)
            djui_hud_set_rotation(0x0000, 0.5, 0.5)
            djui_hud_render_rect(x1 + 2.5, y - 2, 6, 8)
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_render_rect(buttonX, y - 3, 1, 10)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                currAlts.currSkin = math_max(currAlts.currSkin - 1, 1)
                update_character_skin(currChar, currAlts.currSkin)
                inputLockTimer = -inputLockTimerTo
            end
        end
        -- Right Arrow
        if currAlts.currSkin < #currAlts then
            -- Changed arrows to mimick the ones seen in the options menu
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_set_rotation(0x2000, 0.5, 0.5)
            djui_hud_render_rect(x2, y, 5, 5)
            djui_hud_set_color(0, 0, 0, 255)
            djui_hud_set_rotation(0x0000, 0.5, 0.5)
            djui_hud_render_rect(x2 - 3.5, y - 2, 6, 8)
            djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
            djui_hud_render_rect(buttonX + 69, y - 3, 1, 10)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                currAlts.currSkin = currAlts.currSkin + 1
                update_character_skin(currChar, currAlts.currSkin)
                inputLockTimer = inputLockTimerTo
            end
        end
        -- use an input lock to prevent cycling too fast
        if inputLockTimer > 0 then
            inputLockTimer = inputLockTimer - 1
        elseif inputLockTimer < 0 then
            inputLockTimer = inputLockTimer + 1
        end
    end
end

hook_render_in_menu(hud_render)